%define section free

Name:           nekohtml
Version:        0.9.3
Release:        1jpp
Epoch:          0
Summary:        HTML scanner and tag balancer
License:        Apache-like
URL:            http://www.apache.org/~andyc/neko/doc/html/
Source0:        http://www.apache.org/~andyc/neko/nekohtml-0.9.3.tar.gz
Source1:        %{name}-filter.sh
Patch0:         %{name}-crosslink.patch
Group:          Text Processing/Markup/HTML
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Vendor:         JPackage Project
Distribution:   JPackage

BuildArch:      noarch
BuildRequires:  ant, jpackage-utils >= 0:1.5, xerces-j2 >= 0:2.3.0
BuildRequires:  java-javadoc, xerces-j2-javadoc-xni, xerces-j2-javadoc-impl
Requires:       xerces-j2 >= 0:2.3.0, jpackage-utils >= 0:1.5

%description
NekoHTML is a simple HTML scanner and tag balancer that enables
application programmers to parse HTML documents and access the
information using standard XML interfaces. The parser can scan HTML
files and "fix up" many common mistakes that human (and computer)
authors make in writing HTML documents.  NekoHTML adds missing parent
elements; automatically closes elements with optional end tags; and
can handle mismatched inline element tags.
NekoHTML is written using the Xerces Native Interface (XNI) that is
the foundation of the Xerces2 implementation. This enables you to use
the NekoHTML parser with existing XNI tools without modification or
rewriting code.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%package        demo
Summary:        Demo for %{name}
Group:          Text Processing/Markup/HTML
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    demo
Demonstrations and samples for %{name}.


%prep
%setup -q
%patch0 -p0
find . -name "*.jar" -exec rm -f {} \;


%build
export CLASSPATH=$(build-classpath xerces-j2)
ant -f build-html.xml \
    -Djarfile=%{name}-%{version}.jar \
    -DjarfileXni=%{name}-xni-%{version}.jar \
    -DjarfileSamples=%{name}-samples-%{version}.jar \
    -Dj2se.javadoc=%{_javadocdir}/java \
    -Dxni.javadoc=%{_javadocdir}/xerces-j2-xni \
    -Dxerces.javadoc=%{_javadocdir}/xerces-j2-impl \
    clean package test


%install
rm -rf $RPM_BUILD_ROOT

# Jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 bin/package/nekohtml-*/{%{name},%{name}-xni}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/
pushd $RPM_BUILD_ROOT%{_javadir}
for jar in %{name} %{name}-xni; do
  ln -sf $jar-%{version}.jar $jar.jar
done
popd

# Scripts
install -Dpm 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}-filter

# Samples
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 bin/package/nekohtml-*/%{name}-samples-%{version}.jar \
  $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/

# Javadocs
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr bin/package/nekohtml-*/doc/html/javadoc/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# Avoid having javadocs in %doc.
rm -rf bin/package/nekohtml-*/doc/html/javadoc

# Fix link between docs and javadoc.
pushd bin/package/nekohtml-*/doc/html
ln -sf %{_javadocdir}/%{name}-%{version} javadoc
popd


%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(0644,root,root,0755)
%doc LICENSE* README* TODO* bin/package/nekohtml-*/doc/*
%attr(755,root,root) %{_bindir}/%{name}-filter
%{_javadir}/%{name}*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}


%changelog
* Sat Jul  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.9.3-1jpp
- Update to 0.9.3.
- Add nekohtml-filter script.

* Thu Apr  1 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.9.2-1jpp
- Update to 0.9.2.

* Sat Dec 13 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.8.3-1jpp
- Update to 0.8.3.

* Sat Nov 15 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.8.2-1jpp
- Update to 0.8.2.

* Wed Oct  1 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.8.1-1jpp
- Update to 0.8.1.
- Crosslink with local J2SE and XNI javadocs.
- Save .spec in UTF-8.

* Thu Jun 26 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.7.7-1jpp
- Update to 0.7.7.

* Sun May 11 2003 David Walluck <david@anti-microsoft.org> 0:0.7.6-1jpp
- 0.7.6
- update for JPackage 1.5

* Sat Mar 29 2003 Ville Skyttä <ville.skytta at iki.fi> - 0.7.4-2jpp
- Rebuilt for JPackage 1.5.

* Tue Mar  4 2003 Ville Skyttä <ville.skytta at iki.fi> - 0.7.4-1jpp
- Update to 0.7.4.

* Mon Feb 24 2003 Ville Skyttä <ville.skytta at iki.fi> - 0.7.3-1jpp
- Update to 0.7.3.
- Built with IBM's 1.3.1 SR3 and xerces-j2 2.3.0.

* Sat Jan 11 2003 Ville Skyttä <ville.skytta at iki.fi> - 0.7.2-1jpp
- Update to 0.7.2.
- Run unit tests when building.

* Tue Dec 10 2002 Ville Skyttä <ville.skytta at iki.fi> - 0.7.1-1jpp
- Update to 0.7.1.

* Sun Nov  3 2002 Ville Skyttä <ville.skytta at iki.fi> - 0.6.8-1jpp
- 0.6.8, first JPackage release.
